#ifndef DUNE_ANNULUS_POINT_CONVERGENCE_TEST_PROBLEM_HH
#define DUNE_ANNULUS_POINT_CONVERGENCE_TEST_PROBLEM_HH

#include <dune/particle/problem/genericIncludes.hh>

#include <dune/particle/surface/planarCircularSurface.hh>
#include <dune/particle/particle/singlePointParticle.hh>
#include <dune/particle/integrand/mongeGaugeIntegrand.hh>
#include <dune/fufem/functiontools/basisinterpolator.hh>

#include <dune/particle/derivative/derivativeVectorField_MongeGaugeSpecialization.hh>


class AnnulusPointConvegenceTestSolution
  : public Dune::VirtualMultiDifferentiableFunction<Dune::FieldVector<double,2>,Dune::FieldVector<double,1>,Dune::FieldVector<size_t,2>>
{
  public:

    typedef Dune::FieldVector<double,2> DomainType;
    typedef Dune::FieldVector<double,1> RangeType;
    typedef Dune::FieldVector<size_t,2> OrderType;

    typedef Dune::VirtualMultiDifferentiableFunction<DomainType,RangeType,OrderType> BaseType;
    using BaseType::evaluate;
        
    AnnulusPointConvegenceTestSolution(const double R, const double height)
    {
      // Coefficients as generated by MATLAB.
      // Alternative: One could also explicitly solve the characterizing linear system here.
      c[0]  = height;
      c[1]  = 2*height*log(R)/(R*R);
      c[2]  = 0;
      c[3]  = 2*height/(R*R);
    }

    RangeType evaluate(const DomainType& x, const OrderType& d) const
    {
      RangeType res = 0;

      const auto r = x.two_norm();
      const auto r2 = r*r;
      const auto r4 = r2*r2;
      const auto log_r = (r > 0) ? log(r) : 0;
      const auto log_r2 = (r > 0) ? log(r2) : 0;

      if(d[0] == 0 && d[1] == 0){
        res = c[0] + c[1]*r2 + c[2]*log_r + c[3]*r2*(log_r-0.5);
      }else if(d[0] == 1 && d[1] == 0){
        res = (r > 0) ? 2*c[1]*x[0] + (c[2]*x[0])/r2 + c[3]*x[0]*log_r2 : 0;
      }else if(d[0] == 0 && d[1] == 1){
        res = (r > 0) ? 2*c[1]*x[1] + (c[2]*x[1])/r2 + c[3]*x[1]*log_r2 : 0;
      }else if(d[0] == 1 && d[1] == 1){
        res = (r > 0) ? (2*x[0]*x[1]*(c[3]*r2-c[2]))/r4 : 0;
      }else if(d[0] == 2 && d[1] == 0){
        res = (r > 0) ? 2*c[1] + c[3] + c[2]/r2 + c[3]*(log_r2-1) - (2*c[2]*x[0]*x[0])/r4 + (2*c[3]*x[0]*x[0])/r2 : 0;
      }else if(d[0] == 0 && d[1] == 2){
        res = (r > 0) ? 2*c[1] + c[3] + c[2]/r2 + c[3]*(log_r2-1) - (2*c[2]*x[1]*x[1])/r4 + (2*c[3]*x[1]*x[1])/r2 : 0;
      }else{
        DUNE_THROW(Dune::NotImplemented, "Not implemented.");
      }

      return res;
    }


  private:

    std::array<double,4> c;
};


class AnnulusPointConvergenceTestProblem
{
  public:

    typedef Dune::BlockVector<Dune::FieldVector<double,1>> Vector;

    typedef PlanarCircularSurface<> Surface;
    typedef SinglePointParticle<> Particle;
    typedef SpatialTransformation<> Transformation;
    typedef ParameterizedMembraneParticleProblem<Surface,Particle,Transformation> Model;
    typedef typename Model::Position Position;

    typedef typename Dune::UGGrid<2> Grid;
    typedef typename Grid::LeafGridView GridView;
    typedef HermiteKNodalBasis<GridView,2> NonconformingBasis;
    typedef ConformingKBasis<NonconformingBasis> Basis;

    typedef typename Model::ConstraintFunctions ConstraintFunctions;
    typedef typename Model::LevelSetFunctions LevelSetFunctions;
    typedef DomainInformation<Basis,LevelSetFunctions> DomainInfo;
    typedef ConstraintFunction<ConstraintFunctions,DomainInfo> Constraints;
    typedef MongeGaugeIntegrand<Constraints> Integrand;
    typedef MembraneAssembler<Integrand,DomainInfo> Assembler;
    typedef MembraneSolver<Model,Basis> Solver;

    static constexpr double R = 1;
    static constexpr double height = 1;

    AnnulusPointConvergenceTestProblem()
      : u(0), surface(1), particle(height), transformation()
    {
    }

    auto solve(const double h)
    {
      //~ // Modify h_ such that it yields a symmetric grid that has 0 as one of its nodes.
      //~ const unsigned int N  = std::round(2./h_);
      //~ const double h  = 2./(N + (N%2)); // Make N even and set h accordingly.
      surface.setPadding(2.6634358*h);

      // Reset quadrature caches.
      LocalParameterizationQuadratureCache<double>::clear();
      CurveQuadratureCache<double,2>::clear();

      // Full model.
      typename Model::Position position(1);
      position[0] = 0;
      pModel = std::make_shared<Model>(surface, particle, transformation);
      pModel->setNumberOfParticles(position.size());
      pModel->setPosition(position);
      const auto& model = *pModel;

      // Set up grid.
      //~ pGrid = MembraneGrid::template makeGrid(model, {N+4, N+4}); // +4 as of the padding
      pGrid = MembraneGrid::template makeGrid(model, h);

      // Set up basis.
      pNonconformingBasis = std::make_shared<NonconformingBasis>(pGrid->leafGridView());
      pBasis = std::make_shared<Basis>(*pNonconformingBasis);
      //~ surface.updateConstraints(*pBasis);
      ConstraintsMachine::updateConstraints(*pBasis, surface, model.transformedParameterizedPoints().first);
      const auto& basis = *pBasis;

      // Collect geometric information.
      levelSetFunctions = model.transformedLevelSets();
      pDomainInfo = std::make_shared<DomainInfo>(basis, levelSetFunctions, 1);
      const auto& domainInfo = *pDomainInfo;
      Debug::dprint("DomainInfo constructed.");

      // Set integrand.
      const auto&& constraintFunctions = model.transformedConstraintFunctions();
      Constraints f(constraintFunctions, domainInfo);
      Integrand integrand(1,0,f);

      // Assemble system.
      Assembler assembler(integrand, domainInfo);
      const auto&& constraintPoints = model.transformedParameterizedPoints();
      Debug::dprint("Assembled.");

      // Solve system.
      pMembraneSolver = std::make_shared<Solver>(assembler.systemMatrix(), assembler.rightHandSide(), model, basis, constraintPoints);
      u = pMembraneSolver->solve();

      // Compute energy.
      Vector Au(u.size());
      assembler.volumeMatrix().mv(u,Au);
      const auto energy = 0.5*(u*Au);
      Debug::dprint("Got energy", energy);
      return energy;
    }


    void solveExactly(const double h_) // (up to interpolation error)
    {
      // Modify h_ such that it yields a symmetric grid that has 0 as one of its nodes.
      const unsigned int N  = std::round(2./h_);
      const double h  = 2./(N + (N%2)); // Make N even and set h accordingly.
      surface.setPadding(2*h);

      // Reset quadrature caches.
      LocalParameterizationQuadratureCache<double>::clear();
      CurveQuadratureCache<double,2>::clear();

      // Full model.
      typename Model::Position position(1);
      position[0] = 0;
      pModel = std::make_shared<Model>(surface, particle, transformation);
      pModel->setNumberOfParticles(position.size());
      pModel->setPosition(position);
      const auto& model = *pModel;

      // Set up grid.
      pGrid = MembraneGrid::template makeGrid(model, {N+4, N+4}); // +4 as of the padding

      // Set up basis.
      pNonconformingBasis = std::make_shared<NonconformingBasis>(pGrid->leafGridView());
      pBasis = std::make_shared<Basis>(*pNonconformingBasis);
      surface.updateConstraints(*pBasis);
      const auto& basis = *pBasis;

      // Collect geometric information.
      levelSetFunctions = model.transformedLevelSets();
      pDomainInfo = std::make_shared<DomainInfo>(basis, levelSetFunctions, 1);
      const auto& domainInfo = *pDomainInfo;
      Debug::dprint("DomainInfo constructed.");

      // Interpolate exact solution.
      AnnulusPointConvegenceTestSolution f(R, 1);
      u.resize(basis.size());
      Functions::interpolate(basis, u, f);
    }


    void saveMembrane(const std::string& fileName = "membrane", const int refinement = 0)
    {
      // Visualize.
      const auto& model = *pModel;
      const auto& domainInfo = *pDomainInfo;
            auto& basis = *pBasis;

      typedef Dune::CutOffBasis<Basis,typename Model::Function,DomainInfo> COBasis;
      COBasis coBasis(basis, domainInfo);
      const auto&& levelSetFunctions = model.transformedLevelSets();
      for(const auto& levelSetFunction : levelSetFunctions)
        coBasis.addInterface(levelSetFunction);

      typedef ParametricPerturbedSurface<Surface,COBasis,Vector> PerturbedSurface;
      PerturbedSurface perturbedSurface(surface, coBasis, u);
      typedef Dune::VTKFunction<typename COBasis::GridView> VTKFunction;
      std::shared_ptr<VTKFunction> vtkFunction = std::make_shared<PerturbedSurface>(perturbedSurface);

      typedef VTKBasisGridFunction<COBasis,Vector> VTKGridFunction;
      std::shared_ptr<VTKGridFunction> vtkGridFunction = std::make_shared<VTKGridFunction>(coBasis, u, "elevation");

      Dune::SubsamplingVTKWriter<typename COBasis::GridView> writer(basis.getGridView(), refinement);
      writer.addVertexData(vtkFunction);
      writer.addVertexData(vtkGridFunction);

      writer.write(fileName, Dune::VTK::OutputType::base64);
      Debug::dprint("Wrote surface.");
    }

    const auto& membrane() const
    {
      return u;
    }

    const auto& basis() const
    {
      return *pBasis;
    }


    // Approach here: Use a high order quadrature rule on the coarse
    // grid and apply it against the exact solution function.
    auto measureError() const
    {
      Dune::FieldVector<double,3> error(0.);
      const auto& basis       = *pBasis;
      const auto& domainInfo  = *pDomainInfo;
      
      // Set up functions.
      BasisMultiDifferentiableGridFunction<Basis,Vector,Dune::FieldVector<size_t,2>> func_u(basis, u);
      AnnulusPointConvegenceTestSolution func_ex(R, 1);
      
      // Iterate over all elements.
      for(const auto& e : elements(basis.getGridView()))
      {
        // Get quadrature rule.
        const bool isInside   = domainInfo.isInside(e);
        const bool isOutside  = domainInfo.isOutside(e);
        
        if(isOutside)
          continue;
        
        const auto tFE = basis.getLocalFiniteElement(e);
        QuadratureRuleKey quadKey(tFE);
        quadKey.setOrder(tFE.localBasis().order()*2 + 10);
        auto quadratureRule = (isInside) ? QuadratureRuleCache<double,2>::rule(quadKey) : LocalParameterizationQuadrature<double>::rule(quadKey, e, domainInfo);
        
        for(const auto& quadPoint : quadratureRule)
        {
          // Update error term.
          const auto& xLocal = quadPoint.position();
          const auto xGlobal = e.geometry().global(xLocal);
          const auto weight = quadPoint.weight()*e.geometry().integrationElement(xLocal);

          const auto dif_H0   = func_u.evaluateLocal(e,xLocal) - func_ex.evaluate(xGlobal);
          auto dif_H1 = func_u.evaluateLocalGradient(e,xLocal);
          dif_H1[0] -= func_ex.evaluate(xGlobal,{1,0});
          dif_H1[1] -= func_ex.evaluate(xGlobal,{0,1});
          const auto dif_H2   = func_u.evaluateLaplacianLocal(e,xLocal) - func_ex.evaluate(xGlobal,{2,0}) - func_ex.evaluate(xGlobal,{0,2});
          
          error[0] += dif_H0*dif_H0*weight;
          error[1] += (dif_H1*dif_H1)*weight;
          error[2] += dif_H2*dif_H2*weight;
        }
      }
      
      for(auto& e : error)
        e = sqrt(e);
      return error;
    }

    auto gradient() const
    {
      // Preparations.
      const auto& model = *pModel;
      const auto&& constraintFunctions = model.transformedConstraintFunctions();
      const auto& domainInfo = *pDomainInfo;
      Constraints f(constraintFunctions, domainInfo);
      Integrand integrand(1,0,f);

      // Compute derivative.
      typedef DerivativeVectorField_MongeGaugeSpecialization<DomainInfo,Model,Solver> VectorField;
      //~ typedef DerivativeVectorField<DomainInfo,Model,Solver> VectorField;
      VectorField V(domainInfo, model, *pMembraneSolver);

      typedef ParticleDerivative<Integrand,VectorField,DomainInfo,Vector> Derivative;
      Derivative derivative(integrand, V, domainInfo, u);

      Debug::dprint("Evaluating gradient.");
      const auto dif = derivative.evaluateGradient(model.getPosition());
      Debug::dprint("Evaluated gradient.");

      return dif;
    }


  protected:

    Dune::ParameterTree params;

          Surface         surface;
    const Particle        particle;
    const Transformation transformation;

    LevelSetFunctions levelSetFunctions;

    std::shared_ptr<Grid>               pGrid;
    std::shared_ptr<NonconformingBasis> pNonconformingBasis;
    std::shared_ptr<Basis>              pBasis;
    std::shared_ptr<DomainInfo>         pDomainInfo;
    std::shared_ptr<Model>              pModel;
    std::shared_ptr<Solver>             pMembraneSolver;


    Vector u;
};
#endif
